package com.mortals.xhx.module.record.web;
import cn.hutool.core.img.ImgUtil;
import cn.hutool.core.io.FileUtil;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.common.IBaseEnum;
import com.mortals.framework.common.Rest;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.BaseEntity;
import com.mortals.framework.utils.ReflectUtils;
import com.mortals.framework.utils.poi.ExcelUtil;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.upload.service.UploadService;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.code.*;
import com.mortals.xhx.common.utils.ImportExcelUtil;
import com.mortals.xhx.common.utils.ReadExcelPictureUtil;
import com.mortals.xhx.module.certificate.model.*;
import com.mortals.xhx.module.certificate.model.vo.CertificateDocumentPdu;
import com.mortals.xhx.module.certificate.service.CertificateCatalogService;
import com.mortals.xhx.module.certificate.service.CertificateDocumentService;
import com.mortals.xhx.module.certificate.service.CertificateIndustryService;
import org.apache.poi.ss.usermodel.PictureData;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.imageio.ImageIO;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.swing.*;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.record.model.ApplyLogEntity;
import com.mortals.xhx.module.record.service.ApplyLogService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.*;
import java.util.List;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
import static java.util.stream.Collectors.toMap;

/**
*
* 证照申请
*
* @author zxfei
* @date 2022-10-14
*/
@RestController
@RequestMapping("apply/log")
public class ApplyLogController extends BaseCRUDJsonBodyMappingController<ApplyLogService,ApplyLogEntity,Long> {

    @Value("${upload.path}")
    private String filePath;

    @Autowired
    private CertificateDocumentService certificateDocumentService;
    @Autowired
    private UserService userService;
    @Autowired
    private CertificateIndustryService certificateIndustryService;
    @Autowired
    private CertificateCatalogService certificateCatalogService;


    public ApplyLogController(){
        super.setModuleDesc( "证照申请");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model,"status", IBaseEnum.getEnumMap(StatusEnum.class));
        this.addDict(model,"holderType", IBaseEnum.getEnumMap(HolderType.class));
        this.addDict(model,"holderIdType", IBaseEnum.getEnumMap(HolderIdType.class));
        this.addDict(model,"generateStatus", IBaseEnum.getEnumMap(GenerateStatus.class));
        this.addDict(model, "createUserId", userService.find(new UserQuery()).stream().collect(toMap(x -> x.getId().toString(), y -> y.getRealName(), (o, n) -> n)));
        super.init(model, context);
    }


    @Override
    protected void doListBefore(ApplyLogEntity query, Map<String, Object> model, Context context) throws AppException {

        if(!ObjectUtils.isEmpty(query.getIndustryId())){
            //获取行业与子行业
            CertificateIndustryEntity industryEntity = certificateIndustryService.get(query.getIndustryId());
            if(ObjectUtils.isEmpty(industryEntity)){
                query.setCatalogId(-1L);
                return;
            }

            List<CertificateIndustryEntity> childsEntities = certificateIndustryService.getDao().selectChildrenCertificateIndustryById(query.getIndustryId().toString());

            List<Long> industryIdList =  childsEntities.stream().map(x -> x.getId()).collect(Collectors.toList());
            industryIdList.add(query.getIndustryId());
/*            List<Long> industryIdList = certificateIndustryService.find(new CertificateIndustryQuery()
                            .ancestors(industryEntity.getAncestors() + "%"))
                    .stream().map(x -> x.getId()).collect(Collectors.toList());
            if(ObjectUtils.isEmpty(industryIdList)) {
                query.setCatalogId(-1L);
                return;
            }*/
            List<Long> catalogIdlist = certificateCatalogService.find(new CertificateCatalogQuery().industryIdList(industryIdList))
                    .stream().map(x -> x.getId()).collect(Collectors.toList());
            if(ObjectUtils.isEmpty(catalogIdlist)) {
                query.setCatalogId(-1L);
                return;
            }
            query.setCatalogIdList(catalogIdlist);
        }


        super.doListBefore(query, model, context);
    }

    /**
     * 预览正本
     */
    @PostMapping(value = "preview/original")
    @UnAuth
    public Rest<Object> previewOriginal(@RequestBody ApplyLogEntity applyLogEntity) {
        Rest<Object> ret = new Rest();
        Map<String, Object> model = new HashMap();
        try {
            String paths = this.service.previewOriginal(applyLogEntity, getContext());
            String[] vals = paths.split(";");
            if(vals.length>1) {
                ret.setCode(VALUE_RESULT_SUCCESS);
                ret.setMsg("生成成功");
                //model.put("mergeDoc", vals[0]);
                model.put("preview", vals[1]);
                ret.setData(model);
            }else {
                ret.setCode(VALUE_RESULT_FAILURE);
                ret.setMsg("生成失败");
            }
        } catch (Exception e) {
            log.error("合成表单异常", e);
            ret.setCode(VALUE_RESULT_FAILURE);
            ret.setMsg(super.convertException(e));

        }
        return ret;
    }

    /**
     * 生成正本
     */
    @PostMapping(value = "generate/original")
    @UnAuth
    public Rest<Object> generateOriginal(@RequestBody ApplyLogEntity applyLogEntity) {
        Rest<Object> ret = new Rest();
        Map<String, Object> model = new HashMap();
        try {
            this.service.generateOriginal(applyLogEntity, getContext());
            ret.setCode(VALUE_RESULT_SUCCESS);
            ret.setMsg("生成成功");
            //model.put("mergeDoc", vals[0]);
            ret.setData(model);
        } catch (Exception e) {
            log.error("合成表单异常", e);
            ret.setCode(VALUE_RESULT_FAILURE);
            ret.setMsg(super.convertException(e));

        }
        return ret;
    }

    /**
     * 档案
     */
    @PostMapping(value = "record")
    @UnAuth
    public Rest<Object> record(@RequestBody ApplyLogEntity applyLogEntity) {
        Rest<Object> ret = new Rest();
        try {
            List<ApplyLogEntity> list = this.service.ApplyRecord(applyLogEntity.getId());
            ret.setCode(VALUE_RESULT_SUCCESS);
            ret.setMsg("查询档案成功");
            ret.setData(list);
            this.recordSysLog(this.request,  " 查询档案成功【成功】");
        } catch (Exception e) {
            log.error("查询档案异常", e);
            ret.setCode(VALUE_RESULT_FAILURE);
            ret.setMsg(super.convertException(e));

        }
        return ret;
    }

    @PostMapping({"/import"})
    public String importFile(MultipartFile file, Long catalogId,Long templateId) {
        JSONObject ret = new JSONObject();
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "导入" + this.getModuleDesc();
        byte code = 1;
        try {
            String fileName = file.getOriginalFilename();
            List<Map<Integer, Object>> returnList = ImportExcelUtil.readExcelContent(fileName,file.getInputStream(),1,null,null);
            Map<String, PictureData> pictureDataMap = ReadExcelPictureUtil.readExcelPictureMap(file);
            Map<String,String> fileMap = ReadExcelPictureUtil.savePicture(this.filePath,pictureDataMap);
            String message = this.service.importData(returnList, fileMap, catalogId, templateId, context);
            model.put("message_info", message);
            this.recordSysLog(this.request, busiDesc + " 【成功】");
        } catch (Exception var13) {
            code = -1;
            this.doException(this.request, busiDesc, model, var13);
        }

        ret.put("code", Integer.valueOf(code));
        ret.put("msg", model.remove("message_info"));
        return ret.toJSONString();
    }

    /** 社会统一信用编码查询 */
    @GetMapping(value = "get/{socialCode}")
    @UnAuth
    public String get(@PathVariable(value="socialCode") String socialCode) {
        Map<String, Object> model = new HashMap();
        if (StringUtils.isEmpty(socialCode)) {
            return this.createFailJsonResp("信用编码不正确");
        } else {
            JSONObject ret = new JSONObject();
            String busiDesc = "扫码查看" + this.getModuleDesc();
            Context context = this.getContext();
            try {

                ApplyLogEntity entity = this.service.getBySocialCode(socialCode);
                if (entity == null) {
                    throw new Exception(busiDesc + "，不存在或已被删除");
                }

                ret.put("data", entity);
                if (!ObjectUtils.isEmpty(context) && !ObjectUtils.isEmpty(context.getUser())) {
                    this.recordSysLog(this.request, busiDesc + " 【成功】");
                }
            } catch (Exception var8) {
                this.doException(this.request, busiDesc, model, var8);
                Object msg = model.get("message_info");
                return this.createFailJsonResp(msg == null ? "系统异常" : msg.toString());
            }

            this.init(model, context);
            ret.put("code", 1);
            ret.put("systemDate", new Date());
            ret.put("msg", model.remove("message_info"));
            ret.put("dict", model.remove("dict"));
            return ret.toJSONString();
        }
    }


    @PostMapping(value = "addInit")
    @UnAuth
    public String add(@RequestBody ApplyLogEntity params) {
        Map<String, Object> model = new HashMap();
        int code = 1;
        Context context = this.getContext();
        String busiDesc = "打开新增" + this.getModuleDesc() + "页面";

        try {
            this.addBefore(model);
            ApplyLogEntity entity = new ApplyLogEntity();
            entity.initAttrValue();
            List<CertificateDocumentEntity> certificateDocumentEntityList = certificateDocumentService.getListByCatalogId(params.getCatalogId());
            List<CertificateDocumentPdu> documentEntityList = new ArrayList<>();
            for(CertificateDocumentEntity item:certificateDocumentEntityList){
                CertificateDocumentPdu pdu = new CertificateDocumentPdu();
                BeanUtils.copyProperties(item, pdu);
                documentEntityList.add(pdu);
            }
            entity.setChildCertificate(documentEntityList);
            model.put("entity", entity);
            this.addAfter(model);
            if (!ObjectUtils.isEmpty(context) && !ObjectUtils.isEmpty(context.getUser())) {
                this.recordSysLog(this.request, busiDesc + " 【成功】");
            }
        } catch (Exception var7) {
            code = -1;
            this.doException(this.request, busiDesc, model, var7);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", Integer.valueOf(code));
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }



    public static void main(String[] args) {
            ImgUtil.pressText(//
                    FileUtil.file("E:\\pic\\back.jpg"), //
                    FileUtil.file("E:\\pic\\back_water.jpg"), //
                    "南方者@版权所有", Color.RED, //文字
                    new Font("宋体", Font.BOLD, 100), //字体
                    0, //x坐标修正值。 默认在中间，偏移量相对于中间偏移
                    0, //y坐标修正值。 默认在中间，偏移量相对于中间偏移
                    0.5f//透明度：alpha 必须是范围 [0.0, 1.0] 之内（包含边界值）的一个浮点数字
            );


    }

}